import React from 'react';
import PropTypes from 'prop-types';

import {bem} from '@steroidsjs/core/hoc';

@bem('FormView')
export default class FormView extends React.PureComponent {

    static propTypes = {
        label: PropTypes.oneOfType([
            PropTypes.string,
            PropTypes.bool,
        ]),
        hint: PropTypes.oneOfType([
            PropTypes.string,
            PropTypes.bool,
        ]),
        required: PropTypes.bool,
        isInvalid: PropTypes.bool,
        layout: PropTypes.shape({
            layout: PropTypes.oneOfType([
                PropTypes.oneOf(['default', 'inline', 'horizontal']),
                PropTypes.string,
                PropTypes.bool,
            ]),
        }),
        size: PropTypes.oneOf(['sm', 'md', 'lg']),
        className: PropTypes.string,
    };

    render() {
        const bem = this.props.bem;
        return (
            <form
                className={bem(
                    bem.block(),
                    this.props.className,
                    this.props.layout.layout === 'horizontal' && 'form-horizontal',
                )}
                onSubmit={this.props.onSubmit}
            >
                {this.props.children}
            </form>
        );
    }

}
